require "Polycode/SceneEntity"

class "SceneLine" (SceneEntity)



function SceneLine:__index__(name)
	if name == "lineWidth" then
		return Polycore.SceneLine_get_lineWidth(self.__ptr)
	elseif name == "lineSmooth" then
		return Polycore.SceneLine_get_lineSmooth(self.__ptr)
	end
end


function SceneLine:__set_callback(name,value)
	if name == "lineWidth" then
		Polycore.SceneLine_set_lineWidth(self.__ptr, value)
		return true
	elseif name == "lineSmooth" then
		Polycore.SceneLine_set_lineSmooth(self.__ptr, value)
		return true
	end
	return false
end


function SceneLine:SceneLine(...)
	if type(arg[1]) == "table" and count(arg) == 1 then
		if ""..arg[1]:class() == "SceneEntity" then
			self.__ptr = arg[1].__ptr
			return
		end
	end
	for k,v in pairs(arg) do
		if type(v) == "table" then
			if v.__ptr ~= nil then
				arg[k] = v.__ptr
			end
		end
	end
	if self.__ptr == nil and arg[1] ~= "__skip_ptr__" then
		self.__ptr = Polycore.SceneLine(unpack(arg))
		__ptr_lookup.SceneLine[self.__ptr] = self
	end
end

function SceneLine:setStart(start)
	local retVal = Polycore.SceneLine_setStart(self.__ptr, start.__ptr)
end

function SceneLine:setEnd(_end)
	local retVal = Polycore.SceneLine_setEnd(self.__ptr, _end.__ptr)
end

function SceneLine:Render()
	local retVal =  Polycore.SceneLine_Render(self.__ptr)
end



if not __ptr_lookup then __ptr_lookup = {} end
__ptr_lookup.SceneLine = {}

function SceneLine:__delete()
	__ptr_lookup.SceneLine[self.__ptr] = nil
	Polycore.delete_SceneLine(self.__ptr)
end
