class "CollisionSceneEntity"



SHAPE_BOX = 0
SHAPE_TERRAIN = 1
SHAPE_SPHERE = 2
SHAPE_MESH = 3
CHARACTER_CONTROLLER = 4
SHAPE_CAPSULE = 5
SHAPE_PLANE = 6
SHAPE_CONE = 7
SHAPE_CYLINDER = 8
function CollisionSceneEntity:__index__(name)
	if name == "lastPosition" then
		retVal = Physics3D.CollisionSceneEntity_get_lastPosition(self.__ptr)
		if __ptr_lookup["Vector3"][retVal] ~= nil then
			return __ptr_lookup["Vector3"][retVal]
		else
			__ptr_lookup["Vector3"][retVal] = _G["Vector3"]("__skip_ptr__")
			__ptr_lookup["Vector3"][retVal].__ptr = retVal
			return __ptr_lookup["Vector3"][retVal]
		end
	elseif name == "enabled" then
		return Physics3D.CollisionSceneEntity_get_enabled(self.__ptr)
	end
end


function CollisionSceneEntity:__set_callback(name,value)
	if name == "enabled" then
		Physics3D.CollisionSceneEntity_set_enabled(self.__ptr, value)
		return true
	end
	return false
end


function CollisionSceneEntity:CollisionSceneEntity(...)
	for k,v in pairs(arg) do
		if type(v) == "table" then
			if v.__ptr ~= nil then
				arg[k] = v.__ptr
			end
		end
	end
	if self.__ptr == nil and arg[1] ~= "__skip_ptr__" then
		self.__ptr = Physics3D.CollisionSceneEntity(unpack(arg))
		__ptr_lookup.CollisionSceneEntity[self.__ptr] = self
	end
end

function CollisionSceneEntity:getSceneEntity()
	local retVal =  Physics3D.CollisionSceneEntity_getSceneEntity(self.__ptr)
	if retVal == nil then return nil end
	if __ptr_lookup["SceneEntity"][retVal] ~= nil then
		return __ptr_lookup["SceneEntity"][retVal]
	else
		__ptr_lookup["SceneEntity"][retVal] = _G["SceneEntity"]("__skip_ptr__")
		__ptr_lookup["SceneEntity"][retVal].__ptr = retVal
		return __ptr_lookup["SceneEntity"][retVal]
	end
end

function CollisionSceneEntity:getType()
	local retVal =  Physics3D.CollisionSceneEntity_getType(self.__ptr)
	return retVal
end

function CollisionSceneEntity:Update()
	local retVal =  Physics3D.CollisionSceneEntity_Update(self.__ptr)
end

function CollisionSceneEntity:getConvexShape()
	local retVal =  Physics3D.CollisionSceneEntity_getConvexShape(self.__ptr)
	if retVal == nil then return nil end
	if __ptr_lookup["btConvexShape"][retVal] ~= nil then
		return __ptr_lookup["btConvexShape"][retVal]
	else
		__ptr_lookup["btConvexShape"][retVal] = _G["btConvexShape"]("__skip_ptr__")
		__ptr_lookup["btConvexShape"][retVal].__ptr = retVal
		return __ptr_lookup["btConvexShape"][retVal]
	end
end

function CollisionSceneEntity:createCollisionShape(entity, type)
	local retVal = Physics3D.CollisionSceneEntity_createCollisionShape(self.__ptr, entity.__ptr, type)
	if retVal == nil then return nil end
	if __ptr_lookup["btCollisionShape"][retVal] ~= nil then
		return __ptr_lookup["btCollisionShape"][retVal]
	else
		__ptr_lookup["btCollisionShape"][retVal] = _G["btCollisionShape"]("__skip_ptr__")
		__ptr_lookup["btCollisionShape"][retVal].__ptr = retVal
		return __ptr_lookup["btCollisionShape"][retVal]
	end
end



if not __ptr_lookup then __ptr_lookup = {} end
__ptr_lookup.CollisionSceneEntity = {}

function CollisionSceneEntity:__delete()
	__ptr_lookup.CollisionSceneEntity[self.__ptr] = nil
	Physics3D.delete_CollisionSceneEntity(self.__ptr)
end
